//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%4561D359001B.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%4561D359001B.cm

//## begin module%4561D359001B.cp preserve=no
//## end module%4561D359001B.cp

//## Module: PlotBackground%4561D359001B; Package body
//## Subsystem: XSPlot::Commands%3DA1AFD101BF
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSPlot/Commands/PlotBackground.cxx

//## begin module%4561D359001B.additionalIncludes preserve=no
//## end module%4561D359001B.additionalIncludes

//## begin module%4561D359001B.includes preserve=yes
#include <XSPlot/Plot/CreateBinnedPlotGroups.h>
#include <XSPlot/Plot/PlotGroup.h>
#include <XSPlot/Plot/PlotSettings.h>
#include <XSPlot/Plot/PlotStyle.h>
#include <XSPlot/Plot/PlotTypes.h>
//## end module%4561D359001B.includes

// PlotBackground
#include <XSPlot/Commands/PlotBackground.h>
//## begin module%4561D359001B.declarations preserve=no
//## end module%4561D359001B.declarations

//## begin module%4561D359001B.additionalDeclarations preserve=yes
//## end module%4561D359001B.additionalDeclarations


// Class PlotBackground 

PlotBackground::PlotBackground()
  //## begin PlotBackground::PlotBackground%4561D47301D4_const.hasinit preserve=no
  //## end PlotBackground::PlotBackground%4561D47301D4_const.hasinit
  //## begin PlotBackground::PlotBackground%4561D47301D4_const.initialization preserve=yes
  : PlotCommand("background", new CreateBinnedPlotGroups(false, false))
  //## end PlotBackground::PlotBackground%4561D47301D4_const.initialization
{
  //## begin PlotBackground::PlotBackground%4561D47301D4_const.body preserve=yes
  isDataRequired(true);
  isActiveModelRequired(false);
  isDivisibleByArea(true);
  addCompLevel(2);
  isBackgroundApplicable(false);
  isLineIDApplicable(true);
  
  // It's a bit confusing, but for this command the values in the background
  // PlotVector will be swapped with the yData PlotVector (in the manipulate 
  // function).  The background PlotVector is intended for plotting only
  // when it is supplementary to separately existing yData.
  PlotAttributes styles;
  styles.symbolStyle = PlotStyle::ASTERISK;
  styles.lineStyle = PlotStyle::NONE;
  setStyleMap(PlotStyle::DATA, styles);
  styles.symbolStyle = PlotStyle::BLANK;
  styles.lineStyle = PlotCommand::standardModelStyle();
  styles.lineStep = true;
  styles.lineWidth = 2;
  setStyleMap(PlotStyle::MODEL, styles);
  styles.lineStep = false;
  styles.lineStyle = PlotStyle::DOTTED;
  setStyleMap(PlotStyle::SOURCES, styles);
  
  //## end PlotBackground::PlotBackground%4561D47301D4_const.body
}


PlotBackground::~PlotBackground()
{
  //## begin PlotBackground::~PlotBackground%4561D47301D4_dest.body preserve=yes
  //## end PlotBackground::~PlotBackground%4561D47301D4_dest.body
}



//## Other Operations (implementation)
void PlotBackground::setRanges (std::vector<PlotGroup*>& plotGroups, const PlotSettings& settings)
{
  //## begin PlotBackground::setRanges%4B1EDA0C0308.body preserve=yes
   Real xlow=0.0, xhigh=0.0;
   PlotGroupCreator::determineXRange(plotGroups,&xlow,&xhigh);
  
   PlotRange& rangeVals = rangeSettings();
   rangeVals.ranges.x1 = xlow;
   rangeVals.ranges.x2 = xhigh;
   rangeVals.yScaleType = settings.yLog() ? PlotStyle::LOG : 
             PlotStyle::LINEAR;
   if (settings.xOption() == CHANNELS)
      rangeVals.xScaleType = PlotStyle::LINEAR;
   else 
      rangeVals.xScaleType = settings.xLog() ? PlotStyle::LOG :
                PlotStyle::LINEAR;
   
   if (rangeVals.yScaleType == PlotStyle::LOG)
   {
      // Let plotting package determine y ranges
      rangeVals.useRangeFlags = PlotStyle::XMIN + PlotStyle::XMAX;
   }
   else
   {
      // Plotting package determines upper y
      rangeVals.ranges.y1 = 0.0;
      rangeVals.useRangeFlags = PlotStyle::XMIN + PlotStyle::XMAX
                        + PlotStyle::YMIN;
   }   
  //## end PlotBackground::setRanges%4B1EDA0C0308.body
}

void PlotBackground::makeLabels (const PlotSettings& settings, StandardLabels& labels) const
{
  //## begin PlotBackground::makeLabels%4B1EDA230137.body preserve=yes
   labels.title = activeModelStatus() ? settings.lookupLabelName("t:data:foldmodel") :
                        settings.lookupLabelName("t:data");
                        
   string xKey(settings.makeXOptionDependentLabel(labels.x));
   // Now y label:
   string yLabel;
   string fullKey(string("y:data") + xKey.substr(1));
   yLabel = settings.lookupLabelName(fullKey);
   settings.insertUnitLabel(yLabel, true);   
   labels.y = yLabel;
   
   if (settings.divideByArea())
   {
      string inverseArea = settings.lookupLabelName("y:suffix:area");
      yLabel += " ";
      yLabel += inverseArea;
      labels.y = yLabel;       
   }
  //## end PlotBackground::makeLabels%4B1EDA230137.body
}

void PlotBackground::manipulate (std::vector<PlotGroup*>& plotGroups, const PlotSettings& settings)
{
  //## begin PlotBackground::manipulate%4B1FC6F6032B.body preserve=yes
   for (size_t i=0; i<plotGroups.size(); ++i)
   {
      std::vector<Real>& back = plotGroups[i]->background.data;
      std::vector<Real>& backErr = plotGroups[i]->background.errors[0];
      std::vector<Real>& data = plotGroups[i]->yData.data;
      std::vector<Real>& dataErr = plotGroups[i]->yData.errors[0];
      data.swap(back);
      dataErr.swap(backErr);
   }
  //## end PlotBackground::manipulate%4B1FC6F6032B.body
}

// Additional Declarations
  //## begin PlotBackground%4561D47301D4.declarations preserve=yes
  //## end PlotBackground%4561D47301D4.declarations

//## begin module%4561D359001B.epilog preserve=yes
//## end module%4561D359001B.epilog
